# SPDX-FileCopyrightText: Copyright (c) 2025, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---
device_type: kv260

job_name: {{ CI_JOB_NAME }}

timeouts:
  job:
    minutes: 90

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}

visibility: public

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/zynqmp-kria-starter-psa/mender.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: GITLAB_PRIVATE_TOKEN
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  boot_character_delay: 30
  test_character_delay: 30
  extra_kernel_args: rootwait

actions:
# Flash firmware and distro images and reset the device
- deploy:
    timeout:
      minutes: 60
    to: flasher
    images:
      ImageA:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      ImageB:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      sd:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
        partition: 1
        format: ext4
        overlays:
          lava: true

- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 15
    method: minimal

# Boot until login prompt is reached
- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 10
    method: minimal
    reset: false
    auto_login:
      login_prompt: '{{ MACHINE }} login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
      - eth0=$(ip -o link show | grep "link/ether" | head -n 1 | awk '-F:' '{print $2}')
      - wait-online.sh $eth0
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@{{ MACHINE }}:.+\$ '
      - '@{{ MACHINE }}:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

- test:
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-mender-tests
            description: "Run Cassini mender tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - lava-test-case cassini-mender-tests --shell "systemctl status mender-connect.service | grep "active""
        from: inline
        name: cassini-mender-tests
        path: inline/cassini-mender-tests.yaml
